<?php
/***************************************************************************\
*                 MRTS - MRTG RRDtool Total Statistics v0.1                 *
*****************************************************************************
* This program is free software; you can redistribute it and/or modify it   *
* under the terms of the GNU General Public License as published by the     *
* Free Software Foundation; either version 2 of the License, or (at your    *
* option) any later version.                                                *
*****************************************************************************
* This script is written by Thor Dreier                                     *
* More information can be found at  http://apt-get.dk/mrts/                 *
\***************************************************************************/

/////////////Modifications for Nagios XI////////////////////
/*
* 	changed CSS classes to fit theme for Nagios XI
* 	eliminated some line breaks in code to make it more compact and more similar to XI's format
*	moved functions to bottom of page to more easily trace MAIN script logic 
*	added wrapper functions to clean $_REQUEST variables 
*	added authorization functions to allow multi-tenancy with Nagios XI
*/


////////////////Nagios XI AUTH////////////////////////////
require_once(dirname(__FILE__).'/../../common.inc.php');

// initialization stuff
pre_init();
// start session
init_session();
// grab GET or POST variables 
grab_request_vars();
// check prereqs
check_prereqs();
// check authentication
check_authentication(false);


///////////////////END XI AUTH///////////////////////////////

/* The directory where the rrd files are located */
  /*$dir = '/var/log/mrtg';*/
$dir = '/var/lib/mrtg';
$extension='.rrd';

/* List all devices that MRTS should'n display, */
$exclude = array('secret', 'topsecret');

/* RRDtool path - where are the the executable located */
$rrdcommand = '/usr/bin/rrdtool';


/***************************************************************************\
*                It should be no need to edit anything below                *
*                   this point, unless there are problems                   *
*****************************************************************************
* - or said in another way - if you change anything radical below here, you *
* have to make the changes public, as this code is GNU licensed code        *
\***************************************************************************/


/***************************************************************************\
*                                 Variables                                 *
\***************************************************************************/

/* File extension of the MRTG-RRD-files */
$extension = '.rrd';

/* This version */
$version = 'v0.1.1';

/* The title */
/*$title = "MRTS - MRTG RRDtool Total Statistics $version";*/
$title="Bandwidth Usage Report";

////////XI Mods, used reqeust wrapper function //////
$name=grab_request_var("name","");
$viewlist=grab_request_var("viewlist","");
$picture=grab_request_var("picture","");
$period=grab_request_var("period","");
$year=grab_request_var("year","");
$month=grab_request_var("month","");
//fetch authorized hosts for this user 
$authIPs = fetch_auth_ips();
$mode = grab_request_var('mode','default');
/////////////////////////////////////////////


/***************************************************************************\
*                                All the rest              					*
\***************************************************************************/

/* Find legalnames */
$legalnames = array();
if($dirhandler = @opendir($dir))
{
	while(($filename = readdir($dirhandler)) !== false)
	{
		if(ereg("$extension$", $filename))
		{
			$filename = substr($filename, 0, -strlen($extension));
			if(!in_array($filename, $exclude))				
				$legalnames[] = $filename;				
		} //end IF
	}//end WHILE 
	closedir($dirhandler);
} //END IF 


/* If a device have been chosen */
if($name!="")
{
	parse_name($name,$ip,$port);
	/* If the device name is valid */
	if(validname($name) && isset($authIPs[$ip]))
	{
		/////////////////GRAPH IMAGES/////////////////
		/* If the script should generate a picture */
		if($picture!="")   //if(isset($_GET['picture']))	
		{
			$fname=filename($name);
			header("content-type: image/png");
			$rrdcommand = "$rrdcommand graph - -v 'Bytes/s' -b 1024 -w 390 DEF:avgin=$fname:ds0:AVERAGE AREA:avgin#00CC00:'Traffic in' DEF:avgout=$fname:ds1:AVERAGE LINE2:avgout#0000FF:'Traffic out'";

			/* Last day */
			if($period=='day')			
				$rrdcommand .= ' -t "Traffic the last day" -s -86400';

			/* Last week */
			else if($period=='week')			
				$rrdcommand .= ' -t "Traffic the last week" -s -604800';

			/* Last month */
			else if($period=='month')			
				$rrdcommand .= ' -t "Traffic the last month" -s -2678400';

			/* Last year */
			else if($period=='year')			
				$rrdcommand .= ' -t "Traffic the last year" -s -31622400';

			/* If year and month is supplied, then generate picture for that month */
			else if(is_numeric($year) && is_numeric($month))
			{
				$name = monthname($month) . ' ' . $year;
				$rrdcommand .= " -t 'Traffic for $name' " . monthstartend($year, $month);
				$rrdcommand .= " -x DAY:1:WEEK:1:DAY:1:86400:%d ";
			}

			echo  `$rrdcommand`;
		}		
		/* If year and month is supplied, then generate page for that month */
		else if(is_numeric($year) && is_numeric($month))
		{
			//determin display mode 
			if($mode=='default')
				echo top($name);
			if($mode=='csv') {
				header("Content-Disposition: attachment; filename={$name}.csv");
				header('Content-type:plain/text'); 				
				print gettext("Bandwidth Usage Report: ").$name."\n\n";
			}	
			
						
			$mname = monthname($month) . ' ' . $year;
			if($mode=='default')
				printf("<img src=\"%s?name=%s&amp;year=%s&amp;month=%s&amp;picture=yes\" alt=\"%s\">", $_SERVER['SCRIPT_NAME'], $name, $year, $month, $mname);
				
			$lastdate = 0;
			//XIMOD: initialize $days array to prevent PHP notices 
			$days = array();
			for($i = 0;$i<32;$i++)
				$days[$i] = array('in' => 0, 'out' => 0);

			/* Get statistics for the selected month */
			if($fp = popen("$rrdcommand fetch " . filename($name) . " AVERAGE -r 864000 ".monthstartend($year, $month), 'r'))
			{
				fgets($fp, 4096);
				while(!feof($fp))
				{
					$line = trim(fgets($fp, 4096));

					if($line != '')
					{
						list($date, $in, $out) = split('( )+', $line);
						list($date) = split(':', $date);
						if($lastdate != 0)
						{
							if(!is_numeric($in))
								$in = 0;
							if(!is_numeric($out))
								$out = 0;

							$in  = $in*($date-$lastdate);
							$out = $out*($date-$lastdate);

							if($month == date('n', $lastdate) && $year == date('Y', $lastdate))
							{
								$day = date('j', $lastdate);
								if($day) {
									$days[$day]['in']  += $in;
									$days[$day]['out'] += $out;
								}
							}

						} //if($lastdate != 0)

						$lastdate = $date;

					} //if($line != '')
				} //while(!feof($fp))
				
				pclose($fp);
				if($mode=='csv')
					showmonth_csv($year, $month, $days);
				else 
					showmonth($year, $month, $days);
			} //if($fp = popen($test, 'r'))

			if($mode=='default')
				echo bottom();
				
		}// END if(is_numeric($year) && is_numeric($month))
		/* Else generate main device page */
		else
		{
			if($mode=='csv') {
				header("Content-Disposition: attachment; filename={$name}.csv");
				header('Content-type:plain/text'); 
				print gettext("Bandwidth Usage Report: ").$name."\n\n";
			}	
			else	
				echo top($name);
				
			/* Find out when the database was last updated */
			if($fp = popen("$rrdcommand info " . filename($name), 'r'))
			{
				$key = '';
				while(!feof($fp))
				{
					@list($key, $value) = split(' = ', trim(fgets($fp, 4096)));
					if($key == 'last_update' && $mode!='csv')
					{
						printf("Last updated: %s<br>\n", date("Y-m-d H:i:s", $value));
						break;
					}
				}
				pclose($fp);
			}
			if($mode=='default') {
				printf("<img src=\"%s?name=%s&amp;period=day&amp;picture=yes\" alt=\"Daily\">", $_SERVER['SCRIPT_NAME'], $name);
				printf("<img src=\"%s?name=%s&amp;period=week&amp;picture=yes\" alt=\"Weekly\">", $_SERVER['SCRIPT_NAME'], $name);
				printf("<img src=\"%s?name=%s&amp;period=month&amp;picture=yes\" alt=\"Monthly\">", $_SERVER['SCRIPT_NAME'], $name);
				printf("<img src=\"%s?name=%s&amp;period=year&amp;picture=yes\" alt=\"Yearly\">\n", $_SERVER['SCRIPT_NAME'], $name);
			}
			$lastdate = 0;
			$months = array();

			/* Get statistics for the last two year */
			if($fp = popen("$rrdcommand fetch " . filename($name) . " AVERAGE -s -63331200 -e +31622400", 'r'))
			{
				fgets($fp, 4096);
				while(!feof($fp))
				{
					$line = trim(fgets($fp, 4096));
					if($line != '')
					{
						list($date, $in, $out) = split('( )+', $line);
						list($date) = split(':', $date);
						if($lastdate != 0)
						{
							if(!is_numeric($in))
								$in = 0;
							if(!is_numeric($out))
								$out = 0;

							$in  = $in*($date-$lastdate);
							$out = $out*($date-$lastdate);
							$year = date('Y', $lastdate);
							$month = date('n', $lastdate);
							
							if(!array_key_exists($year,$months))
								$months[$year]=array();
							if(!array_key_exists($month,$months[$year]))
								$months[$year][$month]=array();
							if(!array_key_exists('in',$months[$year][$month]))
								$months[$year][$month]['in']=0;
							if(!array_key_exists('out',$months[$year][$month]))
								$months[$year][$month]['out']=0;
							
							$months[$year][$month]['in']  += $in;
							$months[$year][$month]['out'] += $out;

						} //if($lastdate != 0)

						$lastdate = $date;

					} //if($line != '')
				} //while(!feof($fp))
				pclose($fp);
				
				$year = date('Y');
				$lastyear = date('Y')-1;
				
				if($mode=='csv') {
					showyear_csv($year, $months[$year]);				
					showyear_csv($lastyear, $months[$lastyear]);
				}				
				else {
					showyear($year, $months[$year]);				
					showyear($lastyear, $months[$lastyear]);
				}


			} //if($fp = popen($test, 'r'))
			if($mode=='default')
				echo bottom();

		} //else

	} //if(validname($name))
	/* If device name has been provided, but it is not valid */
	else{
		//printf("Error: Device graph does not exist or not authorized for host.");
		header("Location: ?viewlist=1");
	} 


} //if(isset($name))
/* If device name has been given, show the main page */
else if($viewlist==1 || empty($legalnames))
{
	//show main listing 
	echo top('All Devices');
?>
<div class='container'>
<table class='standardtable'>
<thead>
<tr><th><?php echo gettext("Host Name"); ?></th>
<th><?php echo gettext("Address"); ?></th>
<th><?php echo gettext("Port"); ?></th>
<th><?php echo gettext("Action"); ?></th></tr>
</thead>
<tbody>
<?php
// sort names
arsort($legalnames);

	$lastip="";
	foreach($legalnames as $name)
	{	
		parse_name($name,$ip,$port);
		
		//XI MOD - adding host authorization
		if(!isset($authIPs[$ip])) continue; //skip unauthorized hosts 
	
		//printf("<a href=\"%s?name=%s\">%s</a><br>\n", $_SERVER['SCRIPT_NAME'], $name, $name);
		echo "<tr>";
		$theip=$ip;
		if($lastip==$ip) //still on the same host  //XI MOD - added hostname with IP for clarity 
		{
			$theip="";
			echo "<td></td>"; //add a blank td
		}
		else
			echo "<td>".$authIPs[$ip]."</td>";

		echo "<td>".$theip."</td>";
		echo "<td>".$port."</td>";
		printf("<td><a href=\"%s?name=%s\">%s</a></td>\n", $_SERVER['SCRIPT_NAME'], $name, gettext("View Report"));
		//echo "<td>".$name."</td>";
		echo "</tr>";
		
		$lastip=$ip;
	}
	
	if(empty($legalnames))
		echo "<tr><td colspan='4'>".gettext("No valid devices are being monitored at this time")."</td></tr>\n"; 
?>
</tbody>
</table>
</div> <!-- end container div -->
<?php
	echo bottom();

} //else
else{
	// redirect to report for first available host
	arsort($legalnames);
	header("Location: ?name=".urlencode($legalnames[0]));
	
}	

//////////////////////////////////////END MAIN/////////////////////////
	
/***************************************************************************\
*                                 Functions                                 *
\***************************************************************************/


/* Change this to get another top on the site */
function top($name)
{ 
	global $request;
	global $name;
	global $legalnames;
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
 <head>
  <title><?php echo $GLOBALS['title']; ?></title>
  
	<?php //XI MOD for stylesheet 
		do_page_head_links(); 
	?>
  
  <style type="text/css">
    .container {margin:10px auto; text-align:center;}
	
	table.bw {margin: 10px auto;} /* added CSS to center large tables */
	
   .datahead,.total1head,.total2head,.data,.total1,.total2 /* removed - border: 1px solid black;*/
   {   width: 50px; }
   
   .datahead,.total1head,.total2head
   { font-size: 12px; font-weight: bold; }

   .data,.total1,.total2
   {  font-size: 10px; }

   .total1,.total1head
   {    background-color: #dddddd;   }

   .total2,.total2head
   {    background-color: #bbbbbb;   }

   h1,h2,h3
   {    text-align: center;   } 
   #mode_icons 
   {position: absolute; top:50px; right:50px; height:50px; width:50px;}
   
	  </style>
	 </head>
	 <body>
	 <div class='container'>
	 <h1><?php echo $GLOBALS['title']; ?></h1>
<?php
	parse_name($name,$ip,$port);
	if($ip=="" || $port=="")
		$title=$name;
	else
		$title=$ip." Port ".$port;	

	print "<h2>{$title}</h2>\n";
	
	//export to csv icon
	$url = 'index.php?';
	foreach($request as $key => $value)
		$url.='&'.urlencode($key).'='.urlencode($value); 

	 if($name!=''){
?>
	<div class="reportexportlinks">
	<?php echo get_add_myreport_html("Bandwidth Report",$_SERVER["REQUEST_URI"],array());?>
	<a title='Export Data As CSV'  href='<?php echo $url;?>&mode=csv'>
	<img alt="Export Data As CSV" src="<?php echo get_base_url();?>/images/csv.png" />
	</a>
	</div>		 

<div style="float: right; text-align: right;">
<form method="get" action="">
<?php echo gettext("View Report For"); ?>: <select name="name">
<?php
	arsort($legalnames);
	foreach($legalnames as $fullname)
	{	
		parse_name($fullname,$ip,$port);
		
		echo "<option value='".$fullname."' ".is_selected($name,$fullname).">".htmlentities($ip)." Port ".htmlentities($port)."</option>";
		
	}
?>
</select>
<input type="submit" name="btnSubmit" value="Go"><br>
<a href="?viewlist=1"><?php echo gettext("See all available reports"); ?></a>
</form>
</div>
<br clear="all">

<?php
		}
		 
}



/* Change this to get another bottom on the site */
function bottom()
{ ?>
  </div> <!-- end main container -->
  <!--<hr />-->
  <div class='container'>
  <?php echo gettext("Report generated by an enhanced version of MRTS for Nagios XI."); ?>
  </div>
 </body>
</html>
<?php 

} //end bottom() 


/* Checks if a name is a valid device name */
function validname($name)
{
	return in_array($name, $GLOBALS['legalnames']);
} //function validname($name)



/* Convert a device name to a file name */
function filename($name)
{
	return $GLOBALS['dir'].'/'.$name.$GLOBALS['extension'];
} //function filename($name)



/* Formats a number with KB, MB etc. */
function humanreadable($size)
{
	$names = array('B', 'KB', 'MB', 'GB', 'TB');
	$times = 0;
	while($size>1024)
	{
		$size = round(($size*100)/1024)/100;
		$times++;
	}
	return "$size " . $names[$times];
} //function humanreadable($size)



/* Convert a month number to a month name */
function monthname($no)
{
	$names = array(1 => 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
	return $names[$no];
} //function monthname($no)



/* Convert year and month number to a string useful for rrdtool  */
function monthstartend($year, $month)
{
	$start = mktime(0, 0, 0, $month, 1, $year);
	if($month==12)
		$end = mktime(0, 0, 0, 1, 1, $year+1);
	else
		$end = mktime(0, 0, 0, $month+1, 1, $year);
	return " -s $start -e $end ";
}



/* Output HTML for a year */
function showyear($year, $months)
{
	$name=grab_request_var("name","");
	$mode=grab_request_var('mode','default');
	$sumyear = array();
	$sumquater = array();

	printf("<h3>Year: %s</h3>\n", $year);
	printf("<table class='standardtable bw'><tr><td></td>\n");

	for($quater=1; $quater<=4; $quater++)
	{
		/* month */
		for($i=($quater-1)*3+1; $i<=($quater-1)*3+3; $i++)		
				printf("<td class=\"datahead\"><a href=\"%s?name=%s&amp;year=%s&amp;month=%s\">%s (%s)</a></td>\n", $_SERVER['SCRIPT_NAME'], $name, $year, $i, monthname($i), $i);
		
		/* quater */
		printf("<td class=\"total1head\">Quarter&nbsp;%s</td>\n", $quater);
	}
	/* year */
	printf("<td class=\"total2head\">Year</td>\n");
	printf("</tr><tr><td class=\"datahead\">In</td>\n");

	for($quater=1; $quater<=4; $quater++)
	{
		/* month */
		for($i=($quater-1)*3+1; $i<=($quater-1)*3+3; $i++)
		{
			if(!array_key_exists($quater,$sumquater))
				$sumquater[$quater]=array();
			if(!array_key_exists('in',$sumquater[$quater]))
				$sumquater[$quater]['in']=0;

			printf("<td class=\"data\">%s</td>\n", humanreadable($months[$i]['in']));
			//$sumyear['in'] += $months[$i]['in'];
			//$sumquater[$quater]['in'] += $months[$i]['in'];
			if(array_key_exists($i,$months))
			{
				if(!array_key_exists('in',$sumyear))
					$sumyear['in']=0;
				if(!array_key_exists('in',$sumquater))
					$sumquater['in']=0;
				$sumyear['in'] += grab_array_var($months[$i],'in',0);
				$sumquater[$quater]['in'] += grab_array_var($months[$i],'in',0);
			}
		}
		/* quater */
		printf("<td class=\"total1\">%s</td>\n", humanreadable($sumquater[$quater]['in']));
	}
	/* year */
	printf("<td class=\"total2\">%s</td>\n", humanreadable($sumyear['in']));
	printf("</tr><tr><td class=\"datahead\">Out</td>\n");

	for($quater=1; $quater<=4; $quater++)
	{
		/* month */
		for($i=($quater-1)*3+1; $i<=($quater-1)*3+3; $i++)
		{
			if(!array_key_exists($quater,$sumquater))
				$sumquater[$quater]=array();
			if(!array_key_exists('out',$sumquater[$quater]))
				$sumquater[$quater]['out']=0;

			printf("<td class=\"data\">%s</td>\n", humanreadable($months[$i]['out']));
			//$sumyear['out'] += $months[$i]['out'];
			//$sumquater[$quater]['out'] += $months[$i]['out'];
			if(array_key_exists($i,$months))
			{
				if(!array_key_exists('out',$sumyear))
					$sumyear['out']=0;
				if(!array_key_exists('out',$sumquater))
					$sumquater['out']=0;
				$sumquater[$quater]['out'] += grab_array_var($months[$i],'out',0);
				$sumyear['out'] += grab_array_var($months[$i],'out',0);
			}
		}
		/* quater */
		printf("<td class=\"total1\">%s</td>\n", humanreadable($sumquater[$quater]['out']));
	}
	/* year */
	printf("<td class=\"total2\">%s</td>\n", humanreadable($sumyear['out']));
	printf("</tr><tr><td class=\"datahead\">Max</td>\n");

	for($quater=1; $quater<=4; $quater++)
	{
		/* month */
		for($i=($quater-1)*3+1; $i<=($quater-1)*3+3; $i++)		
			printf("<td class=\"data\">%s</td>\n", humanreadable(max($months[$i]['in'], $months[$i]['out'])));
		
		/* quater */
		printf("<td class=\"total1\">%s</td>\n", humanreadable(max($sumquater[$quater]['in'], $sumquater[$quater]['out'])));
	}
	/* year */
	printf("<td class=\"total2\">%s</td>\n", humanreadable(max($sumyear['in'], $sumyear['out'])));
	printf("</tr><tr><td class=\"datahead\">Sum</td>\n");

	for($quater=1; $quater<=4; $quater++)
	{
		/* month */
		for($i=($quater-1)*3+1; $i<=($quater-1)*3+3; $i++)		
			printf("<td class=\"data\">%s</td>\n", humanreadable($months[$i]['in'] + $months[$i]['out']));
		
		/* quater */
		printf("<td class=\"total1\">%s</td>\n", humanreadable($sumquater[$quater]['in'] + $sumquater[$quater]['out']));
	}
	/* year */
	printf("<td class=\"total2\">%s</td>\n", humanreadable($sumyear['in'] + $sumyear['out']));
	printf("</tr></table>\n");

} //function showyear($year, $months)


/* Output CSV for a year 
 *	XI MOD: Modified Thor Dreier's showyear() function to create CSV output. All logic written by Thor Dreier.  
 */
function showyear_csv($year, $months)
{
	$name=grab_request_var("name","");
	$sumyear = array();
	$sumquater = array();

	print "Year: {$year}\n";
	
	print ','; //start of table 
	for($quater=1; $quater<=4; $quater++)
	{
		/* month */
		for($i=($quater-1)*3+1; $i<=($quater-1)*3+3; $i++)		
				print monthname($i) . "({$i}),";
			
		/* quater */
		print "Quarter {$quater},";
	}
	/* year */
	print "Year\n"; //endline 
	print "In,";

	for($quater=1; $quater<=4; $quater++)
	{
		/* month */
		for($i=($quater-1)*3+1; $i<=($quater-1)*3+3; $i++)
		{
			if(!array_key_exists($quater,$sumquater))
				$sumquater[$quater]=array();
			if(!array_key_exists('in',$sumquater[$quater]))
				$sumquater[$quater]['in']=0;

			print humanreadable($months[$i]['in']).',';

			if(array_key_exists($i,$months))
			{
				if(!array_key_exists('in',$sumyear))
					$sumyear['in']=0;
				if(!array_key_exists('in',$sumquater))
					$sumquater['in']=0;
				$sumyear['in'] += grab_array_var($months[$i],'in',0);
				$sumquater[$quater]['in'] += grab_array_var($months[$i],'in',0);
			}
		}
		/* quater */
		print humanreadable($sumquater[$quater]['in']).',';
	}
	/* year */
	print humanreadable($sumyear['in']).",\n"; //end line 
	print 'Out,';

	for($quater=1; $quater<=4; $quater++)
	{
		/* month */
		for($i=($quater-1)*3+1; $i<=($quater-1)*3+3; $i++)
		{
			if(!array_key_exists($quater,$sumquater))
				$sumquater[$quater]=array();
			if(!array_key_exists('out',$sumquater[$quater]))
				$sumquater[$quater]['out']=0;

			print humanreadable($months[$i]['out']).',';

			if(array_key_exists($i,$months))
			{
				if(!array_key_exists('out',$sumyear))
					$sumyear['out']=0;
				if(!array_key_exists('out',$sumquater))
					$sumquater['out']=0;
				$sumquater[$quater]['out'] += grab_array_var($months[$i],'out',0);
				$sumyear['out'] += grab_array_var($months[$i],'out',0);
			}
		}
		/* quarter */
		print humanreadable($sumquater[$quater]['out']).',';
	}
	/* year */
	print humanreadable($sumyear['out'])."\n"; //endline 
	//MAX
	print "Max,"; 

	for($quater=1; $quater<=4; $quater++)
	{
		/* month */
		for($i=($quater-1)*3+1; $i<=($quater-1)*3+3; $i++)		
			print humanreadable(max($months[$i]['in'], $months[$i]['out'])).',';
		
		/* quater */
		print humanreadable(max($sumquater[$quater]['in'], $sumquater[$quater]['out'])).',';
	}
	/* year */
	print humanreadable(max($sumyear['in'], $sumyear['out']))."\n"; //newline 
	
	//SUM
	print "Sum,"; 

	for($quater=1; $quater<=4; $quater++)
	{
		/* month */
		for($i=($quater-1)*3+1; $i<=($quater-1)*3+3; $i++)		
			print humanreadable($months[$i]['in'] + $months[$i]['out']).',';
		
		/* quater */
		print humanreadable($sumquater[$quater]['in'] + $sumquater[$quater]['out']).',';
	}
	/* year */
	print humanreadable($sumyear['in'] + $sumyear['out'])."\n";  //newline 

	print "\n\n";
} //function showyear_csv($year, $months)



/* Output HTML for a month */
function showmonth($year, $month, $days)
{
	$summonth = array('in' => 0, 'out' => 0 );
	$daysinmonth = date("t", mktime(0, 0, 0, $month, 1, $year));

	printf("<h3>Month: %s %s</h3>\n", $year, monthname($month));

	for($j=1; $j<=2; $j++)
	{			
		if($j==1)
		{
			$start = 1;
			$end = 16;
		}
		else
		{
			$start = 17;
			$end = $daysinmonth;
		}
		
		printf("<table class='standardtable bw'><tr><td></td>\n");

		for($i=$start; $i<=$end; $i++)			
			printf("<td class=\"datahead\">Day %s</td>\n", $i);
		
		if($j==2)			
			printf("<td class=\"total2head\">Month</td>\n");
		
		printf("</tr><tr><td class=\"datahead\">In</td>\n");

			
		for($i=$start; $i<=$end; $i++)
		{
			printf("<td class=\"data\">%s</td>\n", humanreadable($days[$i]['in']));
			$summonth['in'] += $days[$i]['in'];
		}
		if($j==2)			
			printf("<td class=\"total2\">%s</td>\n", humanreadable($summonth['in']));
		
		printf("</tr><tr><td class=\"datahead\">Out</td>\n");

		for($i=$start; $i<=$end; $i++)
		{
			printf("<td class=\"data\">%s</td>\n", humanreadable($days[$i]['out']));
			$summonth['out'] += $days[$i]['out'];
		}
		if($j==2)			
			printf("<td class=\"total2\">%s</td>\n", humanreadable($summonth['out']));			

		printf("</tr><tr><td class=\"datahead\">Max</td>\n");

		for($i=$start; $i<=$end; $i++)			
			printf("<td class=\"data\">%s</td>\n", humanreadable(max($days[$i]['in'], $days[$i]['out'])));
		
		if($j==2)			
			printf("<td class=\"total2\">%s</td>\n", humanreadable(max($summonth['in'], $summonth['out'])));
		

		printf("</tr><tr><td class=\"datahead\">Sum</td>\n");

		for($i=$start; $i<=$end; $i++)			
			printf("<td class=\"data\">%s</td>\n", humanreadable($days[$i]['in'] + $days[$i]['out']));
		
		if($j==2)			
			printf("<td class=\"total2\">%s</td>\n", humanreadable($summonth['in'] + $summonth['out']));
		
		printf("</tr></table>\n");
		
	} //for($j=1; $j<=2; $j++)
} //showmonth($year, $month, $days)



/* 	Output CSV for a month 
* 	XI MOD: modified original showmonth() function for CSV output
*/
function showmonth_csv($year, $month, $days)
{
	$summonth = array('in' => 0, 'out' => 0 );
	$daysinmonth = date("t", mktime(0, 0, 0, $month, 1, $year));
	$start = 1;
	$end = $daysinmonth;

	print "Month: {$year} ".monthname($month)."\n"; 

	//Day HEADERS
	print ',';
	for($i=$start; $i<=$end; $i++)			
		print "Day {$i},";
		
	//if($j==2)			
		print "Month\n";
	
	print "In,";

	for($i=$start; $i<=$end; $i++)
	{
		print humanreadable($days[$i]['in']).',';
		$summonth['in'] += $days[$i]['in'];
	}	
	//end row 
	print humanreadable($summonth['in'])."\n";
		
	//OUT 
	print "\nOut,"; //newline 
	for($i=$start; $i<=$end; $i++)
	{
		print humanreadable($days[$i]['out']).',';
		$summonth['out'] += $days[$i]['out'];
	}
	//end row 
	print humanreadable($summonth['out'])."\n";			

	//MAX
	print "\nMax,"; //newline 
	for($i=$start; $i<=$end; $i++)			
		print humanreadable(max($days[$i]['in'], $days[$i]['out'])).',';
	//end row 
	print humanreadable(max($summonth['in'], $summonth['out']))."\n";
	
	//SUM
	print "Sum,"; //newline 
	for($i=$start; $i<=$end; $i++)			
		print humanreadable($days[$i]['in'] + $days[$i]['out']).',';
	//end row 		
	print humanreadable($summonth['in'] + $summonth['out'])."\n";
		
	print "\n\n";
} //showmonth_csv($year, $month, $days)
	
function parse_name($name,&$ip,&$port){
	$pos=strpos($name,"_");
	$ip=substr($name,0,$pos);
	$port=substr($name,$pos+1);
}

//XI MOD - added function to check against authorized IP addresses
function fetch_auth_ips() 
{
	$authIPs = array(); 
	$args = array('brevity' => 3);	
	$XML = get_xml_host_objects($args);
	foreach($XML->host as $host)  //build restructured array based on IP address as key
		$authIPs["{$host->address}"] = "{$host->host_name}";
	
	return $authIPs;	
}	

?>